module.exports = function visibleInnerHtmlFactory() {
  const isNodeVisible = elem => Boolean(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);

  const cloneChildrenIfVisible = (/** @type {HTMLElement} */ from, /** @type {HTMLElement} */ to) => {
    if (from.nodeType === Node.ELEMENT_NODE && !isNodeVisible(from)) {
      return;
    }

    to.appendChild(from.cloneNode(false));

    from.childNodes.forEach((node) => {
      cloneChildrenIfVisible(node, to);
    });
  };

  const visibleInnerHtml = (/** @type {HTMLElement} */ node) => {
    const root = document.createElement('div');
    cloneChildrenIfVisible(node, root);
    return root.innerHTML;
  };

  return visibleInnerHtml;
};
